/*
 * Copyright (c) 2013 David MASSENOT - http://artcustomer.fr/
 * 
 * Permission is hereby granted to use, modify, and distribute this file 
 * in accordance with the terms of the license agreement accompanying it.
 */

package artcustomer.framework.extensions.display.ui.list.scroll {
	import flash.display.Shape;
	import flash.utils.getQualifiedClassName;
	
	import artcustomer.framework.base.IDestroyable;
	import artcustomer.framework.errors.IllegalError;
	
	
	/**
	 * AbstractListScrollBar
	 * 
	 * @author David Massenot
	 */
	public class AbstractListScrollBar extends Shape implements IDestroyable {
		private static const FULL_CLASS_NAME:String = 'artcustomer.framework.extensions.display.ui.list.scroll::AbstractListScrollBar';
		
		private static const DEFAULT_COLOR:uint = 0x666666;
		private static const DEFAULT_THICK:int = 6;
		private static const DEFAULT_RADIUS:int = 6;
		
		protected var _color:uint;
		protected var _thick:int;
		protected var _radius:int;
		
		
		/**
		 * Constructor
		 */
		public function AbstractListScrollBar() {
			_color = DEFAULT_COLOR;
			_thick = DEFAULT_THICK;
			_radius = DEFAULT_RADIUS;
		}
		
		
		/**
		 * Draw bar. Called by children.
		 * 
		 * @param	width
		 * @param	height
		 */
		protected function drawBar(width:int, height:int):void {
			this.graphics.clear();
			this.graphics.beginFill(_color, 1);
			this.graphics.drawRoundRect(0, 0, width, height, _radius, _radius);
			this.graphics.endFill();
		}
		
		
		/**
		 * Draw ScrollBar. Override it !
		 * 
		 * @param	size
		 */
		public function draw(size:int):void {
			
		}
		
		/**
		 * Clear ScrollBar.
		 */
		public function clear():void {
			this.graphics.clear();
		}
		
		/**
		 * Destructor
		 */
		public function destroy():void {
			_color = 0;
			_thick = 0;
			_radius = 0;
		}
	}
}