/*
 * Copyright (c) 2012 David MASSENOT - http://artcustomer.fr/
 * 
 * Permission is hereby granted to use, modify, and distribute this file 
 * in accordance with the terms of the license agreement accompanying it.
 */

package artcustomer.framework.extensions.starling.events {
	import flash.display.Stage3D;
	import flash.events.Event;
	
	import artcustomer.framework.extensions.starling.layers.LayerStarling;
	
	
	/**
	 * LayerStarlingEvent
	 * 
	 * @author David Massenot
	 */
	public class LayerStarlingEvent extends Event {
		public static const STARLINGCONTEXT_SETUP:String = 'starlingContextSetup';
		public static const STARLINGCONTEXT_DESTROY:String = 'starlingContextDestroy';
		public static const STARLINGCONTEXT_ERROR:String = 'starlingContextError';
		public static const STARLINGCONTEXT_START:String = 'starlingContextStart';
		
		private var _layerStarling:LayerStarling;
		private var _stage3d:Stage3D;
		private var _error:String;
		
		
		/**
		 * Constructor
		 * 
		 * @param	type
		 * @param	bubbles
		 * @param	cancelable
		 * @param	layerStarling
		 * @param	stage3d
		 * @param	error
		 */
		public function LayerStarlingEvent(type:String, bubbles:Boolean = false, cancelable:Boolean = false, layerStarling:LayerStarling = null, stage3d:Stage3D = null, error:String = null) {
			_layerStarling = layerStarling;
			_stage3d = stage3d;
			_error = error;
			
			super(type, bubbles, cancelable);
		} 
		
		/**
		 * Clone LayerStarlingEvent.
		 * 
		 * @return
		 */
		public override function clone():Event {
			return new LayerStarlingEvent(type, bubbles, cancelable, _layerStarling, _stage3d, _error);
		}
		
		/**
		 * Get String value of LayerStarlingEvent.
		 * 
		 * @return
		 */
		public override function toString():String {
			return formatToString("LayerStarlingEvent", "type", "bubbles", "cancelable", "eventPhase", "layerStarling", "stage3d", "error"); 
		}
		
		
		/**
		 * @private
		 */
		public function get layerStarling():LayerStarling {
			return _layerStarling;
		}
		
		/**
		 * @private
		 */
		public function get stage3d():Stage3D {
			return _stage3d;
		}
		
		/**
		 * @private
		 */
		public function get error():String {
			return _error;
		}
	}
}